Index: src/sas/sasgui/guiframe/local_perspectives/plotting/AnnulusSlicer.py
===================================================================
--- src/sas/sasgui/guiframe/local_perspectives/plotting/AnnulusSlicer.py	(revision d85c194ea2f78cb2b9b3de9c969e1b8ebea6b6d2)
+++ src/sas/sasgui/guiframe/local_perspectives/plotting/AnnulusSlicer.py	(revision 3bdbfcc5cdff8a3a11a9bb19c1cc8c3660a9c2e2)
@@ -1,21 +1,13 @@
-# TODO: the line slicer should listen to all 2DREFRESH events, get the data and slice it
-#      before pushing a new 1D data update.
-
-#
-# TODO: NEED MAJOR REFACTOR
-#
-
-import math
-import wx
-# from copy import deepcopy
-# Debug printout
-from sas.sasgui.guiframe.events import NewPlotEvent
-from sas.sasgui.guiframe.events import StatusEvent
-from sas.sasgui.guiframe.events import SlicerParameterEvent
-from sas.sasgui.guiframe.events import EVT_SLICER_PARS
+import numpy
+from PyQt4 import QtGui
+from PyQt4 import QtCore
+
 from BaseInteractor import _BaseInteractor
 from sas.sasgui.guiframe.dataFitting import Data1D
-
-class AnnulusInteractor(_BaseInteractor):
+import sas.qtgui.GuiUtils as GuiUtils
+from sas.qtgui.GuiUtils import formatNumber
+from sas.qtgui.SlicerModel import SlicerModel
+
+class AnnulusInteractor(_BaseInteractor, SlicerModel):
     """
     Select an annulus through a 2D plot.
@@ -24,19 +16,22 @@
     this class is defined by 2 Ringinterators.
     """
-    def __init__(self, base, axes, color='black', zorder=3):
+    def __init__(self, base, axes, item=None, color='black', zorder=3):
 
         _BaseInteractor.__init__(self, base, axes, color=color)
+        SlicerModel.__init__(self)
+
         self.markers = []
         self.axes = axes
         self.base = base
-        self.qmax = min(math.fabs(self.base.data2D.xmax),
-                        math.fabs(self.base.data2D.xmin))  # must be positive
+        self._item = item
+        self.qmax = min(numpy.fabs(self.base.data.xmax),
+                        numpy.fabs(self.base.data.xmin))  # must be positive
         self.connect = self.base.connect
 
-        # # Number of points on the plot
+        # Number of points on the plot
         self.nbins = 36
         # Cursor position of Rings (Left(-1) or Right(1))
-        self.xmaxd = self.base.data2D.xmax
-        self.xmind = self.base.data2D.xmin
+        self.xmaxd = self.base.data.xmax
+        self.xmind = self.base.data.xmin
 
         if (self.xmaxd + self.xmind) > 0:
@@ -45,9 +40,9 @@
             self.sign = -1
         # Inner circle
-        self.inner_circle = RingInteractor(self, self.base.subplot,
+        self.inner_circle = RingInteractor(self, self.axes,
                                            zorder=zorder,
                                            r=self.qmax / 2.0, sign=self.sign)
         self.inner_circle.qmax = self.qmax
-        self.outer_circle = RingInteractor(self, self.base.subplot,
+        self.outer_circle = RingInteractor(self, self.axes,
                                            zorder=zorder + 1, r=self.qmax / 1.8,
                                            sign=self.sign)
@@ -56,21 +51,5 @@
         self._post_data()
 
-        # Bind to slice parameter events
-        self.base.Bind(EVT_SLICER_PARS, self._onEVT_SLICER_PARS)
-
-    def _onEVT_SLICER_PARS(self, event):
-        """
-        receive an event containing parameters values to reset the slicer
-
-        :param event: event of type SlicerParameterEvent with params as
-            attribute
-
-        """
-        wx.PostEvent(self.base,
-                     StatusEvent(status="AnnulusSlicer._onEVT_SLICER_PARS"))
-        event.Skip()
-        if event.type == self.__class__.__name__:
-            self.set_params(event.params)
-            self.base.update()
+        self.setModelFromParams()
 
     def set_layer(self, n):
@@ -92,5 +71,4 @@
         self.inner_circle.clear()
         self.base.connect.clearall()
-        self.base.Unbind(EVT_SLICER_PARS)
 
     def update(self):
@@ -108,5 +86,4 @@
         can restore on Esc.
         """
-        self.base.freeze_axes()
         self.inner_circle.save(ev)
         self.outer_circle.save(ev)
@@ -120,23 +97,22 @@
         """
         # Data to average
-        data = self.base.data2D
-        # If we have no data, just return
-        if data == None:
+        data = self.base.data
+        if data is None:
             return
 
         from sas.sascalc.dataloader.manipulations import Ring
-        rmin = min(math.fabs(self.inner_circle.get_radius()),
-                   math.fabs(self.outer_circle.get_radius()))
-        rmax = max(math.fabs(self.inner_circle.get_radius()),
-                   math.fabs(self.outer_circle.get_radius()))
-        # if the user does not specify the numbers of points to plot
+        rmin = min(numpy.fabs(self.inner_circle.get_radius()),
+                   numpy.fabs(self.outer_circle.get_radius()))
+        rmax = max(numpy.fabs(self.inner_circle.get_radius()),
+                   numpy.fabs(self.outer_circle.get_radius()))
+        # If the user does not specify the numbers of points to plot
         # the default number will be nbins= 36
-        if nbins == None:
+        if nbins is None:
             self.nbins = 36
         else:
             self.nbins = nbins
-        # # create the data1D Q average of data2D
+        # Create the data1D Q average of data2D
         sect = Ring(r_min=rmin, r_max=rmax, nbins=self.nbins)
-        sector = sect(self.base.data2D)
+        sector = sect(self.base.data)
 
         if hasattr(sector, "dxl"):
@@ -148,43 +124,41 @@
         else:
             dxw = None
-        new_plot = Data1D(x=(sector.x - math.pi) * 180 / math.pi,
+        new_plot = Data1D(x=(sector.x - numpy.pi) * 180 / numpy.pi,
                           y=sector.y, dy=sector.dy)
         new_plot.dxl = dxl
         new_plot.dxw = dxw
-        new_plot.name = "AnnulusPhi" + "(" + self.base.data2D.name + ")"
-
-        new_plot.source = self.base.data2D.source
-        # new_plot.info=self.base.data2D.info
+        new_plot.name = "AnnulusPhi" + "(" + self.base.data.name + ")"
+        new_plot.title = "AnnulusPhi" + "(" + self.base.data.name + ")"
+
+        new_plot.source = self.base.data.source
         new_plot.interactive = True
-        new_plot.detector = self.base.data2D.detector
+        new_plot.detector = self.base.data.detector
         # If the data file does not tell us what the axes are, just assume...
         new_plot.xaxis("\\rm{\phi}", 'degrees')
         new_plot.yaxis("\\rm{Intensity} ", "cm^{-1}")
         if hasattr(data, "scale") and data.scale == 'linear' and \
-                self.base.data2D.name.count("Residuals") > 0:
+                self.base.data.name.count("Residuals") > 0:
             new_plot.ytransform = 'y'
             new_plot.yaxis("\\rm{Residuals} ", "/")
 
-        new_plot.group_id = "AnnulusPhi" + self.base.data2D.name
-        new_plot.id = "AnnulusPhi" + self.base.data2D.name
+        new_plot.group_id = "AnnulusPhi" + self.base.data.name
+        new_plot.id = "AnnulusPhi" + self.base.data.name
         new_plot.is_data = True
         new_plot.xtransform = "x"
         new_plot.ytransform = "y"
-        self.base.parent.update_theory(data_id=data.id, theory=new_plot)
-        wx.PostEvent(self.base.parent, NewPlotEvent(plot=new_plot, title="AnnulusPhi"))
+        variant_plot = QtCore.QVariant(new_plot)
+        GuiUtils.updateModelItemWithPlot(self._item, variant_plot, new_plot.id)
+
+        if self.update_model:
+            self.setModelFromParams()
+        self.draw()
+
 
     def moveend(self, ev):
         """
         Called when any dragging motion ends.
-        Post an event (type =SlicerParameterEvent)
-        to plotter 2D with a copy  slicer parameters
-        Call  _post_data method
-        """
-        self.base.thaw_axes()
-        # Post parameters to plotter 2D
-        event = SlicerParameterEvent()
-        event.type = self.__class__.__name__
-        event.params = self.get_params()
-        wx.PostEvent(self.base, event)
+        Redraw the plot with new parameters.
+        """
+        self._post_data(self.nbins)
 
     def restore(self):
@@ -204,18 +178,16 @@
         pass
 
-    def get_params(self):
+    def getParams(self):
         """
         Store a copy of values of parameters of the slicer into a dictionary.
-
         :return params: the dictionary created
-
         """
         params = {}
-        params["inner_radius"] = math.fabs(self.inner_circle._inner_mouse_x)
-        params["outer_radius"] = math.fabs(self.outer_circle._inner_mouse_x)
+        params["inner_radius"] = numpy.fabs(self.inner_circle._inner_mouse_x)
+        params["outer_radius"] = numpy.fabs(self.outer_circle._inner_mouse_x)
         params["nbins"] = self.nbins
         return params
 
-    def set_params(self, params):
+    def setParams(self, params):
         """
         Receive a dictionary and reset the slicer with values contained
@@ -224,24 +196,13 @@
         :param params: a dictionary containing name of slicer parameters and
             values the user assigned to the slicer.
-
-        """
-        inner = math.fabs(params["inner_radius"])
-        outer = math.fabs(params["outer_radius"])
+        """
+        inner = numpy.fabs(params["inner_radius"])
+        outer = numpy.fabs(params["outer_radius"])
         self.nbins = int(params["nbins"])
-        # # Update the picture
+        # Update the picture
         self.inner_circle.set_cursor(inner, self.inner_circle._inner_mouse_y)
         self.outer_circle.set_cursor(outer, self.outer_circle._inner_mouse_y)
-        # # Post the data given the nbins entered by the user
+        # Post the data given the nbins entered by the user
         self._post_data(self.nbins)
-
-    def freeze_axes(self):
-        """
-        """
-        self.base.freeze_axes()
-
-    def thaw_axes(self):
-        """
-        """
-        self.base.thaw_axes()
 
     def draw(self):
@@ -278,31 +239,15 @@
         self.sign = sign
         # # Create a marker
-        try:
-            # Inner circle marker
-            x_value = [self.sign * math.fabs(self._inner_mouse_x)]
-            self.inner_marker = self.axes.plot(x_value, [0], linestyle='',
-                                               marker='s', markersize=10,
-                                               color=self.color, alpha=0.6,
-                                               pickradius=5, label="pick",
-                                               zorder=zorder,
-                                               visible=True)[0]
-        except:
-            x_value = [self.sign * math.fabs(self._inner_mouse_x)]
-            self.inner_marker = self.axes.plot(x_value, [0], linestyle='',
-                                               marker='s', markersize=10,
-                                               color=self.color, alpha=0.6,
-                                               label="pick",
-                                               visible=True)[0]
-            message = "\nTHIS PROTOTYPE NEEDS THE LATEST"
-            message += " VERSION OF MATPLOTLIB\n"
-            message += "Get the SVN version that is at "
-            message += " least as recent as June 1, 2007"
-
-            owner = self.base.base.parent
-            wx.PostEvent(owner, StatusEvent(status="AnnulusSlicer: %s" % message))
-
+        # Inner circle marker
+        x_value = [self.sign * numpy.fabs(self._inner_mouse_x)]
+        self.inner_marker = self.axes.plot(x_value, [0], linestyle='',
+                                           marker='s', markersize=10,
+                                           color=self.color, alpha=0.6,
+                                           pickradius=5, label="pick",
+                                           zorder=zorder,
+                                           visible=True)[0]
         # Draw a circle
         [self.inner_circle] = self.axes.plot([], [], linestyle='-', marker='', color=self.color)
-        # the number of points that make the ring line
+        # The number of points that make the ring line
         self.npts = 40
 
@@ -325,11 +270,6 @@
         """
         self.clear_markers()
-        try:
-            self.inner_marker.remove()
-            self.inner_circle.remove()
-        except:
-            # Old version of matplotlib
-            for item in range(len(self.axes.lines)):
-                del self.axes.lines[0]
+        self.inner_marker.remove()
+        self.inner_circle.remove()
 
     def get_radius(self):
@@ -347,13 +287,13 @@
         y = []
         for i in range(self.npts):
-            phi = 2.0 * math.pi / (self.npts - 1) * i
-
-            xval = 1.0 * self._inner_mouse_x * math.cos(phi)
-            yval = 1.0 * self._inner_mouse_x * math.sin(phi)
+            phi = 2.0 * numpy.pi / (self.npts - 1) * i
+
+            xval = 1.0 * self._inner_mouse_x * numpy.cos(phi)
+            yval = 1.0 * self._inner_mouse_x * numpy.sin(phi)
 
             x.append(xval)
             y.append(yval)
 
-        self.inner_marker.set(xdata=[self.sign * math.fabs(self._inner_mouse_x)],
+        self.inner_marker.set(xdata=[self.sign * numpy.fabs(self._inner_mouse_x)],
                               ydata=[0])
         self.inner_circle.set_data(x, y)
@@ -366,5 +306,4 @@
         self._inner_save_x = self._inner_mouse_x
         self._inner_save_y = self._inner_mouse_y
-        self.base.freeze_axes()
 
     def moveend(self, ev):
@@ -396,17 +335,14 @@
         self.update()
 
-
-    def get_params(self):
+    def getParams(self):
         """
         Store a copy of values of parameters of the slicer into a dictionary.
-
         :return params: the dictionary created
-
         """
         params = {}
-        params["radius"] = math.fabs(self._inner_mouse_x)
+        params["radius"] = numpy.fabs(self._inner_mouse_x)
         return params
 
-    def set_params(self, params):
+    def setParams(self, params):
         """
         Receive a dictionary and reset the slicer with values contained
@@ -435,6 +371,6 @@
         self.base = base
         self.is_inside = side
-        self.qmax = min(math.fabs(self.base.data.xmax),
-                        math.fabs(self.base.data.xmin))  # must be positive
+        self.qmax = min(numpy.fabs(self.base.data.xmax),
+                        numpy.fabs(self.base.data.xmin))  # must be positive
         self.connect = self.base.connect
 
@@ -448,5 +384,5 @@
             self.sign = -1
         # Inner circle
-        self.outer_circle = RingInteractor(self, self.base.subplot, 'blue',
+        self.outer_circle = RingInteractor(self, self.axes, 'blue',
                                            zorder=zorder + 1, r=self.qmax / 1.8,
                                            sign=self.sign)
@@ -455,27 +391,8 @@
         self._post_data()
 
-        # Bind to slice parameter events
-        # self.base.Bind(EVT_SLICER_PARS, self._onEVT_SLICER_PARS)
-
-    def _onEVT_SLICER_PARS(self, event):
-        """
-        receive an event containing parameters values to reset the slicer
-
-        :param event: event of type SlicerParameterEvent with params as
-            attribute
-        """
-        wx.PostEvent(self.base,
-                     StatusEvent(status="AnnulusSlicer._onEVT_SLICER_PARS"))
-        event.Skip()
-        if event.type == self.__class__.__name__:
-            self.set_params(event.params)
-            self.base.update()
-
     def set_layer(self, n):
         """
         Allow adding plot to the same panel
-
         :param n: the number of layer
-
         """
         self.layernum = n
@@ -489,5 +406,4 @@
         self.outer_circle.clear()
         self.base.connect.clearall()
-        # self.base.Unbind(EVT_SLICER_PARS)
 
     def update(self):
@@ -498,5 +414,5 @@
         # Update locations
         self.outer_circle.update()
-        # if self.is_inside != None:
+        self._post_data()
         out = self._post_data()
         return out
@@ -507,5 +423,4 @@
         can restore on Esc.
         """
-        self.base.freeze_axes()
         self.outer_circle.save(ev)
 
@@ -521,5 +436,5 @@
 
         # If we have no data, just return
-        if data == None:
+        if data is None:
             return
         mask = data.mask
@@ -527,7 +442,7 @@
 
         rmin = 0
-        rmax = math.fabs(self.outer_circle.get_radius())
-
-        # # create the data1D Q average of data2D
+        rmax = numpy.fabs(self.outer_circle.get_radius())
+
+        # Create the data1D Q average of data2D
         mask = Ringcut(r_min=rmin, r_max=rmax)
 
@@ -536,5 +451,4 @@
         else:
             out = (mask(data))
-        # self.base.data.mask=out
         return out
 
@@ -566,5 +480,5 @@
         pass
 
-    def get_params(self):
+    def getParams(self):
         """
         Store a copy of values of parameters of the slicer into a dictionary.
@@ -574,8 +488,8 @@
         """
         params = {}
-        params["outer_radius"] = math.fabs(self.outer_circle._inner_mouse_x)
+        params["outer_radius"] = numpy.fabs(self.outer_circle._inner_mouse_x)
         return params
 
-    def set_params(self, params):
+    def setParams(self, params):
         """
         Receive a dictionary and reset the slicer with values contained
@@ -585,15 +499,9 @@
             values the user assigned to the slicer.
         """
-        outer = math.fabs(params["outer_radius"])
-        # # Update the picture
+        outer = numpy.fabs(params["outer_radius"])
+        # Update the picture
         self.outer_circle.set_cursor(outer, self.outer_circle._inner_mouse_y)
-        # # Post the data given the nbins entered by the user
+        # Post the data given the nbins entered by the user
         self._post_data()
-
-    def freeze_axes(self):
-        self.base.freeze_axes()
-
-    def thaw_axes(self):
-        self.base.thaw_axes()
 
     def draw(self):
